<template>
    <div class="player">
        <List :idPlaylist="id_playlist" list-single-view="true" :songs="playlist">
        </List>
        <form id="add-song-to-playlist" @submit="checkAndAddToPlaylist($event)">
            <input v-model="ytVideoLink" placeholder="Enter link to YouTube video here">
            <input v-model="videoName" placeholder="Name - Ist das nötig?"><br>
            <button class="btn">Add</button>
        </form>

        <!--PLaylist Vorschlagen in Raum - entfällt-->
        <!---->
        <!--<select>-->
            <!--<option v-for="room in rooms">{{room.name}}</option>-->
        <!--</select>-->
        <!---->
        <!--<button>OK</button>-->
    </div>
</template>
<script>
    import List from '../list/list'
    import WS from '../../websocket_con'
    import {store, mutations} from '../../store'

    export default {
        name: 'Playlist',
        components: {List},
        props: {
            id_playlist: Number
        },
        computed: {
            rooms() {
                return store.rooms;
            },
            playlist() {
                return store.playlist;
            }
        },
        data() {
            return {
                //rooms: [],
                songs: [{id: 1, name: 'SONG1', link: 'link1'}, {id: 2, name: 'SONG2', link: 'link2'}],
                ytVideoLink: '',
                videoName: '',
                length: ''
            }
        },
        created() {
            WS.send(JSON.stringify({apiToken: localStorage.token, action: 'getRooms'}));
            WS.send(JSON.stringify({apiToken: localStorage.token, action: 'getPlaylist'}));
        },
        methods: {
            checkAndAddToPlaylist(event) {
                event.preventDefault();
                console.log(this.$youtube.getIdFromUrl(this.ytVideoLink))
                let self = this;
                if(this.$youtube.getIdFromUrl(this.ytVideoLink) !== null) {
                    var xmlhttp = new XMLHttpRequest();
                    xmlhttp.onreadystatechange = function() {
                        if (this.readyState == 4 && this.status == 200) {
                            let response =  JSON.parse(this.responseText);
                            let videoName = response.title;
                            WS.send(JSON.stringify({apiToken: localStorage.token, action: 'addSong', name: videoName, url: self.ytVideoLink, idPlaylist : self.id_playlist}));
                           // this.songs.push({action: 'addSong', name: this.videoName, url: this.ytVideoLink, idPlaylist : this.id_playlist})
                        }
                    };
                    xmlhttp.open("GET","https://noembed.com/embed?url="+this.ytVideoLink, true);
                    xmlhttp.send();

                    console.log(this.store.playlist)

                }
            }
        }
    }

</script>

<style scoped lang="scss">
    #add-song-to-playlist {
        display: flex;
        padding: 20px;

        input {
            flex-grow: 1;
            border-right: none;
        }
    }
</style>
